/*
 * network.c: A plugin for the Video Disk Recorder
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id$
 */


#include <vdr/plugin.h>
#include <vdr/osd.h>
#include <iostream>
#include <fstream>
#include <iomanip>
using namespace std;

static const char *VERSION        = "0.0.1";
static const char *DESCRIPTION    = "Netzwerkeinstellung";
static const char *MAINMENUENTRY  = "Netzwerkeinstellung";

//---------------- Start

class Netzwerk : public cOsdObject{
private:
   cOsdBase *MyOsd;
   char edit  [10] [80];
   char zeile [80];
   int x;
   int y;
   int k;
   int i;
   int j;
   int l;
   char m;
   int n;
   int o;
   int p;
   int q;
   int r;
   char txtbuffer [1];
   eDvbColor bgzeilea;
   eDvbColor bgzeileb;
   eDvbColor bgzeilec;
   eDvbColor bgzeiled;
   eDvbColor bgzeilee;
   eDvbColor txtzeilea;
   eDvbColor txtzeileb;
   eDvbColor txtzeilec;
   eDvbColor txtzeiled;
   eDvbColor txtzeilee;
public:
  Netzwerk(void);
  ~Netzwerk();
  virtual void Show(void);
  virtual eOSState ProcessKey(eKeys Key);
};

Netzwerk::Netzwerk(void)
{
  txtbuffer [1] = '\0';
  k=1;
  l=0;	
  x = y = 0;	
  MyOsd = NULL;
  int g=0;
  ifstream infile("/etc/sysconfig/network/ifcfg-eth0");
  while (infile.getline(zeile,80))
  {
     strcpy( edit[g], zeile);
     g++;

  }
  if (edit [5][15] == '\'') strcpy( edit[5], "REMOTE_IPADDR=\'000.000.000.000\'");

}

Netzwerk::~Netzwerk()
{
   if ( r ==1 ) {
     if (edit [5][15] == '0' && edit [5][16] == '0' && edit [5][17] == '0') strcpy( edit[5], "REMOTE_IPADDR=\'\'");
     ofstream outdaten("/etc/sysconfig/network/ifcfg-eth0");
     outdaten << edit[0] << "\n" << edit[1] << "\n" << edit[2] << "\n" << edit[3] << "\n" << edit[4] << "\n" << edit[5] << "\n" << edit[6] << "\n" << edit[7] << "\n" << edit[8] << endl;
   }
   delete MyOsd;
}

void Netzwerk::Show(void)
{
   MyOsd = cOsd::OpenRaw(100, 50);
   if (MyOsd) {
      MyOsd->Create(0, 0, 400, 400, 2);
      MyOsd->AddColor(clrBackground);
      MyOsd->AddColor(clrCyan);
      MyOsd->AddColor(clrWhite);
      MyOsd->AddColor(clrBlack);
      MyOsd->AddColor(clrRed);
//      MyOsd->AddColor(clrYellow);
//      MyOsd->AddColor(clrBlue);
      MyOsd->Clear();
      MyOsd->Fill(0,0,400,26,clrCyan);
      MyOsd->Text(30,0,"Netzwerkeinstellungen",clrBlack,clrCyan);
      MyOsd->Text(5,30,"Tastenbelgung:",clrWhite,clrBackground);
      MyOsd->Text(5,60,"Blaue Taste = +",clrWhite,clrBackground);
      MyOsd->Text(5,90,"Gelbe Taste = -",clrWhite,clrBackground);
      MyOsd->Text(5,120,"OK = zurck und speichern",clrWhite,clrBackground);
      MyOsd->Text(5,150,"Exit = zurck ohne speichern",clrWhite,clrBackground);
      MyOsd->Text(5,180,"Pfeiltasten = Navigation",clrWhite,clrBackground);
      MyOsd->Text(5,240,"Um Netzwerkeinstellung zuzuweisen",clrWhite,clrBackground);
      MyOsd->Text(5,270,"unter Einstellungen Neu starten",clrWhite,clrBackground);
      MyOsd->Flush();
   }
}

eOSState Netzwerk::ProcessKey(eKeys Key)
{
  eOSState state = cOsdObject::ProcessKey(Key);
  if (state == osUnknown) {
     switch (Key & ~k_Repeat) {
       case kUp:
       if (k > 1) {
         --k;
         l=0;
       }
       break;
       case kDown:
       if (k < 5) {
         ++k;
         l=0;
       }
       break;
       case kLeft:
       if (l > 0) {
         l--;
         if ( l == 3) l--;
         if ( l == 7) l--;
         if ( l == 11) l--;
         }
       break;
       case kRight:
       if (l < 14)  {
       	 l++;
       	 if ( l == 3) l++;
         if ( l == 7) l++;
         if ( l == 11) l++;
         }
       break;
       case kYellow:
       if(edit [n] [q] > '0')  {
          edit [n] [q] = edit [n] [q]-1;
          }	
        break;
        case kBlue:
        if( l == 0) {
        if(edit [n] [q] < '2') {
          edit [n] [q] = edit [n] [q]+1;
          }
        }
        else if (l == 4) {
        if(edit [n] [q] < '2') {
          edit [n] [q] = edit [n] [q]+1;
          }
        }
        else if (l == 8) {
        if(edit [n] [q] < '2') {
          edit [n] [q] = edit [n] [q]+1;
          }
        }
        else if (l == 12) {
        if(edit [n] [q] < '2') {
          edit [n] [q] = edit [n] [q]+1;
          }
        }
        else {
          if(edit [n] [q] < '9') {
            edit [n] [q] = edit [n] [q]+1;
            }
        }
        break;
        case kRed:
        break;
        case kBack:
        r = 0;
        return osEnd;
        case kOk:
        r = 1;
        return osEnd;
        default: return state;
        }


     MyOsd->Clear();
     if (k == 1) { // ZeilenID
     	bgzeilea = clrCyan;  // Hintergrundfarbe
     	txtzeilea = clrBlack; //textfarbe
     	i=8;  //Stelle in der Zeile
     	n=2;  //Zeilennummer hier eingeben
     	o=200;  //OSD Zeilenpostition
     	p=60; //OSD Zeilenhhe
     	MyOsd->Fill(0,p,400,p+26,clrCyan);
     	for (j=0 ; j < l ; ++j, ++i) {
          txtbuffer [0] = edit[n][i];
          MyOsd->Text(o,p,txtbuffer,clrBlack,clrCyan);
          o=o+12;
        }
        ++j;
        q = i;
        txtbuffer [0] = edit[n][i];
        MyOsd->Text(o,p,txtbuffer,clrWhite,clrRed);
        o=o+12;
        ++i;
        for ( ; j <= 14 ; ++j, ++i) {
          txtbuffer [0] = edit[n][i];
          MyOsd->Text(o,p,txtbuffer,clrBlack,clrCyan);
          o=o+12;
        }
        }
     else {
        m=8;  // Stelle in der Zeile
        o=200; //OSD Zeilenpostition
        bgzeilea =clrBackground; //Hintergrundfarbe
        txtzeilea = clrWhite; //textfarbe
        for (int j=0 ; j<=14 ; ++j, ++m) {
          txtbuffer [0] = edit[2][m];  // Zeilenummer steht hier
          MyOsd->Text(o,60,txtbuffer,clrWhite,clrBackground);
          o=o+12;
          }
        }
     MyOsd->Text(5,60,"IP-Adresse",txtzeilea,bgzeilea);
     if (k == 2) { // ZeilenID
     	bgzeileb = clrCyan;  // Hintergrundfarbe
     	txtzeileb = clrBlack; //textfarbe
     	i=9;  //Stelle in der Zeile
     	n=3;  //Zeilennummer hier eingeben
     	o=200;  //OSD Zeilenpostition
     	p=90;  //OSD Zeilenhhe
     	MyOsd->Fill(0,p,400,p+26,clrCyan);
     	for (j=0 ; j < l ; ++j, ++i) {
          txtbuffer [0] = edit[n][i];
          MyOsd->Text(o,p,txtbuffer,clrBlack,clrCyan);
          o=o+12;
        }
        ++j;
        q = i;
        txtbuffer [0] = edit[n][i];
        MyOsd->Text(o,p,txtbuffer,clrWhite,clrRed);
        o=o+12;
        ++i;
        for ( ; j <= 14 ; ++j, ++i) {
          txtbuffer [0] = edit[n][i];
          MyOsd->Text(o,p,txtbuffer,clrBlack,clrCyan);
          o=o+12;
        }
        }
        else {
        m=9;  // Stelle in der Zeile
        o=200; //OSD Zeilenpostition
        bgzeileb = clrBackground; //Hintergrundfarbe
     	txtzeileb = clrWhite; //textfarbe
        for (int j=0 ; j<=14 ; ++j, ++m) {
          txtbuffer [0] = edit[3][m];  // Zeilenummer steht hier
          MyOsd->Text(o,90,txtbuffer,clrWhite,clrBackground);
          o=o+12;
          }
        }
     MyOsd->Text(5,90,"Subnetzmaske",txtzeileb,bgzeileb);
     if (k == 3) { // ZeilenID
     	bgzeilec = clrCyan;  // Hintergrundfarbe
     	txtzeilec = clrBlack; //textfarbe
     	i=15;  //Stelle in der Zeile
     	n=5;  //Zeilennummer hier eingeben
     	o=200;  //OSD Zeilenpostition
     	p=120;  //OSD Zeilenhhe
     	MyOsd->Fill(0,p,400,p+26,clrCyan);
     	for (j=0 ; j < l ; ++j, ++i) {
          txtbuffer [0] = edit[n][i];
          MyOsd->Text(o,p,txtbuffer,clrBlack,clrCyan);
          o=o+12;
        }
        ++j;
        q = i;
        txtbuffer [0] = edit[n][i];
        MyOsd->Text(o,p,txtbuffer,clrWhite,clrRed);
        o=o+12;
        ++i;
        for ( ; j <= 14 ; ++j, ++i) {
          txtbuffer [0] = edit[n][i];
          MyOsd->Text(o,p,txtbuffer,clrBlack,clrCyan);
          o=o+12;
        }
        }
        else {
        m=15;  // Stelle in der Zeile
        o=200; //OSD Zeilenpostition
        bgzeilec = clrBackground; //Hintergrundfarbe
     	txtzeilec = clrWhite; //textfarbe
        for (int j=0 ; j<=14 ; ++j, ++m) {
          txtbuffer [0] = edit[5][m];  // Zeilenummer steht hier
          MyOsd->Text(o,120,txtbuffer,clrWhite,clrBackground);
          o=o+12;
          }
        }
      MyOsd->Text(5,120,"Standartgateway",txtzeilec,bgzeilec);
      if (k == 4) { // ZeilenID
     	bgzeiled = clrCyan;  // Hintergrundfarbe
     	txtzeiled = clrBlack; //textfarbe
     	i=11;  //Stelle in der Zeile
     	n=1;  //Zeilennummer hier eingeben
     	o=200;  //OSD Zeilenpostition
     	p=150;  //OSD Zeilenhhe
     	MyOsd->Fill(0,p,400,p+26,clrCyan);
     	for (j=0 ; j < l ; ++j, ++i) {
          txtbuffer [0] = edit[n][i];
          MyOsd->Text(o,p,txtbuffer,clrBlack,clrCyan);
          o=o+12;
        }
        ++j;
        q = i;
        txtbuffer [0] = edit[n][i];
        MyOsd->Text(o,p,txtbuffer,clrWhite,clrRed);
        o=o+12;
        ++i;
        for ( ; j <= 14 ; ++j, ++i) {
          txtbuffer [0] = edit[n][i];
          MyOsd->Text(o,p,txtbuffer,clrBlack,clrCyan);
          o=o+12;
        }
        }
        else {
        m=11;  // Stelle in der Zeile
        o=200; //OSD Zeilenpostition
        bgzeiled = clrBackground; //Hintergrundfarbe
     	txtzeiled = clrWhite; //textfarbe
        for (int j=0 ; j<=14 ; ++j, ++m) {
          txtbuffer [0] = edit[1][m];  // Zeilenummer steht hier
          MyOsd->Text(o,150,txtbuffer,clrWhite,clrBackground);
          o=o+12;
          }
        }
     MyOsd->Text(5,150,"Broatcasting",txtzeiled,bgzeiled);
      if (k == 5) { // ZeilenID
     	bgzeilee = clrCyan;  // Hintergrundfarbe
     	txtzeilee = clrBlack; //textfarbe
     	i=9;  //Stelle in der Zeile
     	n=4;  //Zeilennummer hier eingeben
     	o=200;  //OSD Zeilenpostition
     	p=180;  //OSD Zeilenhhe
     	MyOsd->Fill(0,p,400,p+26,clrCyan);
     	for (j=0 ; j < l ; ++j, ++i) {
          txtbuffer [0] = edit[n][i];
          MyOsd->Text(o,p,txtbuffer,clrBlack,clrCyan);
          o=o+12;
        }
        ++j;
        q = i;
        txtbuffer [0] = edit[n][i];
        MyOsd->Text(o,p,txtbuffer,clrWhite,clrRed);
        o=o+12;
        ++i;
        for ( ; j <= 14 ; ++j, ++i) {
          txtbuffer [0] = edit[n][i];
          MyOsd->Text(o,p,txtbuffer,clrBlack,clrCyan);
          o=o+12;
        }
        }
        else {
        m=9;  // Stelle in der Zeile
        o=200; //OSD Zeilenpostition
        bgzeilee = clrBackground; //Hintergrundfarbe
     	txtzeilee = clrWhite; //textfarbe
        for (int j=0 ; j<=14 ; ++j, ++m) {
          txtbuffer [0] = edit[4][m];  // Zeilenummer steht hier
          MyOsd->Text(o,180,txtbuffer,clrWhite,clrBackground);
          o=o+12;
          }
        }
     MyOsd->Text(5,180,"Netzwerkmaske",txtzeilee,bgzeilee);
     MyOsd->Fill(0,0,400,26,clrCyan);
     MyOsd->Text(30,0,"Netzwerkeinstellungen",clrBlack,clrCyan);
     MyOsd->Flush();
     state = osContinue;
     }
  return state;
}


class cPluginNetwork : public cPlugin {
private:
  // Add any member variables or functions you may need here.
public:
  cPluginNetwork(void);
  virtual ~cPluginNetwork();
  virtual const char *Version(void) { return VERSION; }
  virtual const char *Description(void) { return DESCRIPTION; }
  virtual const char *CommandLineHelp(void);
  virtual bool ProcessArgs(int argc, char *argv[]);
  virtual bool Start(void);
  virtual void Housekeeping(void);
  virtual const char *MainMenuEntry(void) { return MAINMENUENTRY; }
  virtual cOsdObject *MainMenuAction(void);
  virtual cMenuSetupPage *SetupMenu(void);
  virtual bool SetupParse(const char *Name, const char *Value);
  };



cPluginNetwork::cPluginNetwork(void)
{
  // Initialize any member variables here.
  // DON'T DO ANYTHING ELSE THAT MAY HAVE SIDE EFFECTS, REQUIRE GLOBAL
  // VDR OBJECTS TO EXIST OR PRODUCE ANY OUTPUT!
}

cPluginNetwork::~cPluginNetwork()
{
  // Clean up after yourself!
}

const char *cPluginNetwork::CommandLineHelp(void)
{
  // Return a string that describes all known command line options.
  return NULL;
}

bool cPluginNetwork::ProcessArgs(int argc, char *argv[])
{
  // Implement command line argument processing here if applicable.
  return true;
}

bool cPluginNetwork::Start(void)
{
  // Start any background activities the plugin shall perform.
  return true;
}

void cPluginNetwork::Housekeeping(void)
{
  // Perform any cleanup or other regular tasks.
}

cOsdObject *cPluginNetwork::MainMenuAction(void)
{
  // Perform the action when selected from the main VDR menu.
  return new Netzwerk;
}

cMenuSetupPage *cPluginNetwork::SetupMenu(void)
{
  // Return a setup menu in case the plugin supports one.
  return NULL;
}

bool cPluginNetwork::SetupParse(const char *Name, const char *Value)
{
  // Parse your own setup parameters and store their values.
  return false;
}

VDRPLUGINCREATOR(cPluginNetwork); // Don't touch this!
